// tslint:disable
/**
 * Accounts
 * The Accounts API manages banking accounts for bank customers. This API manages two primary types of resources:    * *Accounts* (or _internal_ accounts) are those controlled by the   financial institution (FI). Account holders can perform a various operations   on such accounts: Users may view balances and account details,   open new accounts, lock internal accounts, blocking new banking activity on the account   until they unlock it. Users may also close accounts. The FI can freeze or unfreeze accounts   if they suspect fraudulent or other malicious or suspicious activity.   Users map also transfer money, view transactions, etc. using other Apiture APIs.   * *External Accounts* are accounts controlled by an external   financial institution. These are also known as _linked accounts_.   The user can perform fewer operations on external accounts,   primarily scheduling transfers between and an external account   and an internal account, using other Apiture APIs.   Accounts are instances of a banking _product_ (see the Products API). The product defines the type, rate, terms, attributes, and capabilities of accounts attached to the product. Accounts may be either _personal_ accounts (also known as _retail_ accounts) or _business_ accounts (accounts for businesses, institutions, trusts, non-profits, etc., also known as _commercial accounts_).   A user can list their existing accounts and see the balances of those accounts (based on entitlements) and may have permission to change the account name and label and description. Each account has a _primary user_, which is a bank user (via the Users service). The primary user has full management and entitlements for the account, receives mailings such as statements or tax documents.   For personal (retail) accounts, an account has a primary owner and may have additional joint owners. For business (commercial) accounts, the account owner is the business organization and one or more authorized signers who have account access entitlements.   Because the account number is sensitive data, it is not included by default in account representations. The masked account number is returned in the `accountNumbers` object. To also receive the full account number when fetching an account, include the `?unmasked=true` option. When linking an external account, the full account number should be in the `accountNumbers.full` property in the request. The `accountNumbers.full` property is included with the 201 response of creating an account.   This API also manages additional resources which are associated with accounts. For personal accounts, one can get the list of owners (the primary owner and joint owners). The account owner can also view and update the account's beneficiaries. For business accounts, the account holders can view the account's authorized signers: those who have authorization to conduct activity against the account.
 *
 * OpenAPI spec version: 0.37.2
 * Contact: api@apiture.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

export * from './api';
export * from './configuration';
