// tslint:disable
/**
 * Business Verifications
 * This API manages the set of operations that allow financial institutions to verify business identities as well as the identities of authorized representatives  connected to the business.  Vetting business identites can help financial  institutions standardize and build consistency in decisioning processes. This vetting consists of verifying the business as well as the  authorized signers associated with the business.  **Buisness Identification consists of the following attributes:**   * `businessName` The name of the business  * `addressLine1` Line 1 of the businesses street address  * `addressLine2` Line 2 of the businesses street address  * `city` The businesses city  * `regionCode` The businesses region code  * `postalCode` The businesses postal code  * `countryCode` The businesses country code  * `identification.taxId` The business's tax ID number (Federal Employer Identification Number)  **Authorized Signer Identification consists of the following attributes:**   * `firstName` The legal first name of the authorized signer  * `lastName` The legal last name of the authorized signer  * `identification.taxId` The federal tax ID of the authorized signer  _A verification report accepts an array of authorized signers to allow for verifying  multiple identities associated with a business._  ## Submitting a request to generate a verification report  A _verification report_ can be generated by passing the above data points in a `POST /verificationReports`. The response will contain an *`input`* object which will echo the data that was sent on the POST request.  It will also contain an  *`output`* object which will hold the unique `transactionId` and state for the report as well as any risk factors, risk factor codes and risk factor  descriptions flagged by the report.  It is possible to link an organization resource to a verification report  by passing an `apiture:organization` URI in the `_links` object when calling a `POST /verificationReports`.  If the optional `apiture:organization` link is supplied to the `POST /businessVerifications` call, you can retrieve that organizations verification status by calling `GET /businessVerifications?organizationUri={organizationUri}`.   If `apiture:organization` is not included in this `POST`, results can  be retrieved by calling `GET /verificationReports/{verificationReportId}`  ## Checking the verification status for an organization  If the optional `apiture:organization` link was passed on the `POST /verificationReports`, it is possible to view the verification status of that organization by calling  `GET /businessVerifications?organizationUri=/organization/organization/{organizationId}`. The response from `GET /businessVerifications` will contain an embedded list of of  *`businessVerifications`*, each of which will contain a *`type`*. The two possible values are *`verificationReport`* or *`administratorApproval`*.   A *`verificationReport`* will point back to a verification report resource.   An *`administratorApproval`* will point back to an Approval resource.   The presence of an *`administratorApproval`* record signifies that a member of the  financial institution has made a decision regarding the verification  status of an organization.  This decision acts as an override to any  previous verification report results. If a verification report is run and  successfully verifies the identity of the business, an approval  record will be automatically generated with a `state: 'passed'`.
 *
 * OpenAPI spec version: 0.10.2
 * Contact: api@apiture.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

export * from './api';
export * from './configuration';
