// tslint:disable
/**
 * Invitations
 * This API allows digital banking customers to send invitations to other people to become joint owners on personal accounts or to become authorized signers of business organizations.  When a user creates a new invitation (`createInvitation` below), the service sends an email, on behalf of the financial institution, to the invitee's email address with instructions to accept the invitation by visiting a web page. The link in the generated email includes parameters that describe the invitation resource, including but not limited to `invitationId`.  The `invitationId` is required on the `verifyInvitation` operation below.  The \"shared secret\" is a string the invitee shares the inviter to verify their identity.  See (`sharedSecret` below)  Invitation States may be one of the following:    * **`sent`** Invitation sent to invitee   * **`accepted`** Invitation accepted by invitee   * **`completed`** Invitee has been added to their invited role   * **`revoked`** Invitation revoked by inviter   * **`expired`** Invitation expired  The invitation also references the account or organization they are being invited to join, depending on the `type` of the invitation. For joint owner invitations, other existing joint owners on the account can see outstanding invitations for the account. For authorized signer invitation, other existing joint owners can see outstanding invitations for the business organization.  The Inviter should share the secret with the invitee through another secure channel (such as face to face or in a phone conversation) so that unauthorized people cannot accept the invitation.  The Inviter can `revoke` an invitation if the state of the invitation is `sent`.  When the invitee visits the web form listed in their invitation email, they enter the `sharedSecret` to accept. The client can use the `verifyInvitation` operation below to determine if the invitee entered the secret correctly. If they enter the data correctly, the invitation is `accepted`.  If not already users, invitees must register as users on the financial institution's digital banking platform in order to assume these roles. Unverified users must also execute the financial institution's identity verification process before they are added as a joint user or authorized signer.  Once added as a joint user or authorized signer, the invitation is `completed`.  Inviters can update an invitation's shared secret. Inviters can also request an invitation be resent, or they can revoke an invitation. Unaccepted invitations expire after some time (such as 30 or 45 days).
 *
 * OpenAPI spec version: 0.3.3
 * Contact: api@apiture.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

export * from './api';
export * from './configuration';
