// tslint:disable
/// <reference path="./custom.d.ts" />
/**
 * Statements
 * **Warning: The Statements API is deprecated.** The features of this API are now available in the Documents API via the `getStatements` operation. **This API will be removed by July 1, 2020.**   This API provides access to monthly statements for accounts. The user can query this API to list statements for one or more accounts. Statements may also be queried based on time intervals:     * the start and end date    * a start or end date and a period, such as statements for the first 6 months of a year    * an end date and a period, such as statements for the last 6 months.   Each statement resource includes summary properties which describe the account, and contains a link (`apiture:statement`) to the downloadable statement document, typically PDF.
 *
 * OpenAPI spec version: 0.7.0
 * Contact: api@apiture.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import * as Url from 'url';
import { SdkConfiguration } from './configuration';
import globalAxios, { AxiosPromise, AxiosInstance } from 'axios';

const BASE_PATH = '/statements'.replace(/\/+$/, '');

export const API_VERSION = '0.7.0';

/**
 *
 * @export
 */
export const COLLECTION_FORMATS = {
  csv: ',',
  ssv: ' ',
  tsv: '\t',
  pipes: '|',
};

/**
 *
 * @export
 * @interface RequestArgs
 */
export interface RequestArgs {
  url: string;
  options: any;
}

/**
 *
 * @export
 * @class BaseAPI
 */
export class BaseAPI {
  protected configuration?: SdkConfiguration;

  constructor(
    configuration?: SdkConfiguration,
    protected basePath: string = BASE_PATH,
    protected axios: AxiosInstance = globalAxios,
  ) {
    if (configuration) {
      this.configuration = { basePath: BASE_PATH, ...configuration };
    } else {
      this.configuration = { basePath: BASE_PATH };
    }

    this.parseHost();
  }

  public getBasePath() {
    return this.basePath;
  }

  private parseHost() {
    const hostUrl = this.configuration.host || '';
    let parsedUrl = hostUrl;
    if (hostUrl.indexOf('http://') < 0 && hostUrl.indexOf('https://') < 0) {
      parsedUrl = 'https://' + hostUrl;
    }
    this.basePath = parsedUrl + this.configuration.basePath || '';
  }

  public setAccessToken(newToken?: string) {
    if (typeof newToken === 'string') {
      this.configuration.accessToken = newToken;
    } else {
      throw new Error(`Expected string value, received ${newToken}/${typeof newToken}`);
    }
  }

  public setApiKey(newKey?: string) {
    if (typeof newKey === 'string') {
      this.configuration.apiKey = newKey;
    } else {
      throw new Error(`Expected string value, received ${newKey}/${typeof newKey}`);
    }
  }

  public setHost(newHost?: string) {
    if (typeof newHost === 'string') {
      this.configuration.host = newHost;
      this.parseHost();
    } else {
      throw new Error(`Expected string value, received ${newHost}/${typeof newHost}`);
    }
  }
}

/**
 *
 * @export
 * @class RequiredError
 * @extends {Error}
 */
export class RequiredError extends Error {
  name: 'RequiredError' = 'RequiredError';
  constructor(public field: string, msg?: string) {
    super(msg);
  }
}

/**
 * An abstract schema used to define other request-only schemas. This is a [HAL](https://tools.ietf.org/html/draft-kelly-json-hal-08) resource representation, minus the `_error` defined in `abstractResource`.
 * @export
 * @interface AbstractRequest
 */
export interface AbstractRequest {
  /**
   * An optional map of links, mapping each link relation to a link object. This model defines the `_links` object of HAL representations.
   * @type {{ [key: string]: Link; }}
   * @memberof AbstractRequest
   */
  _links?: { [key: string]: Link };
  /**
   * An optional map of nested resources, mapping each nested resource name to a nested resource representation.
   * @type {any}
   * @memberof AbstractRequest
   */
  _embedded?: any;
  /**
   * The URI of a [resource profile](https://developer.apiture.com/docs/concepts/profiles/) which describes the representation.
   * @type {string}
   * @memberof AbstractRequest
   */
  _profile?: string;
}

/**
 * An abstract schema used to define other schemas for request and response bodies. This is a [HAL](https://tools.ietf.org/html/draft-kelly-json-hal-08) resource representation. This model contains hypermedia `_links`, and either optional domain object data with `_profile` and optional `_embedded` objects, or an `_error` object. In responses, if the operation was successful, this object will not include the `_error`, but if the operation was a 4xx or 5xx error, this object will not include `_embedded` or any data fields, only `_error` and optionally `_links`.
 * @export
 * @interface AbstractResource
 */
export interface AbstractResource extends AbstractRequest {
  /**
   * An object which describes an error. This value is omitted if the operation succeeded without error.
   * @type {Error}
   * @memberof AbstractResource
   */
  _error?: Error;
}

/**
 * Different representations of an account number.
 * @export
 * @interface AccountNumbers
 */
export interface AccountNumbers {
  /**
   * A partial account number that does not contain all the digits of the full account number. This masked number appears in statements or in user experience presentation. It is sufficient for a user to differentiate this account from other accounts they hold, but is not sufficient for initiating transfers, etc. The first character is the mask character and is repeated; this does not indicate that the full account number is the same as the mask length. This value is derived and immutable.
   * @type {string}
   * @memberof AccountNumbers
   */
  masked?: string;
  /**
   * The full account number. This value only appears when `?unmasked=true` is passed on the `GET` request. Not included in the summary representation of the account that is included in account collection responses. This value is derived and immutable.
   * @type {string}
   * @memberof AccountNumbers
   */
  full?: string;
}

/**
 * The data associated with this attribute.
 * @export
 * @interface AttributeValue
 */
export interface AttributeValue {}

/**
 * An optional map of name/value pairs which contains additional dynamic data about the resource.
 * @export
 * @interface Attributes
 */
export interface Attributes {
  [key: string]: AttributeValue;
}

/**
 * A collection of resources. This is an abstract model schema which is extended to define specific resource collections.
 * @export
 * @interface Collection
 */
export interface Collection extends AbstractResource {
  /**
   * The number of items in the collection. This value is _optional_ and may be omitted if the count is not computable efficiently. If a filter is applied to the collection (either implicitly or explicitly), the count, if present, indicates the number of items that satisfy the filter.
   * @type {number}
   * @memberof Collection
   */
  count?: number;
  /**
   * The start index of this page of items.
   * @type {number}
   * @memberof Collection
   */
  start?: number;
  /**
   * The maximum number of items per page.
   * @type {number}
   * @memberof Collection
   */
  limit?: number;
  /**
   * The name of the collection.
   * @type {string}
   * @memberof Collection
   */
  name?: string;
}

/**
 * Describes an error in an API request or in a service called via the API.
 * @export
 * @interface Error
 */
export interface Error {
  /**
   * A localized message string describing the error condition.
   * @type {string}
   * @memberof Error
   */
  message: string;
  /**
   * A unique identifier for this error instance. This may be used as a correlation ID with the root cause error (i.e. this ID may be logged at the source of the error). This is is an opaque string.
   * @type {string}
   * @memberof Error
   */
  _id?: string;
  /**
   * The HTTP status code associate with this error.
   * @type {number}
   * @memberof Error
   */
  statusCode?: number;
  /**
   * An error identifier which indicates the category of error and associate it with API support documentation or which the UI tier can use to render an appropriate message or hint. This provides a finer level of granularity than the `statusCode`. For example, instead of just 400 Bad Request, the `type` may be much more specific. such as `integerValueNotInAllowedRange` or `numericValueExceedsMaximum` or `stringValueNotInAllowedSet`.
   * @type {string}
   * @memberof Error
   */
  type?: string;
  /**
   * An [RFC 3339](https://tools.ietf.org/html/rfc3339) UTC time stamp indicating when the error occurred.
   * @type {Date}
   * @memberof Error
   */
  occurredAt?: Date;
  /**
   * Informative values or constraints which describe the error. For example, for a value out of range error, the attributes may specify the `minimum` and `maximum` values. This allows clients to present error messages as they see fit (the API does not assume the client/presentation tier). The set of attributes varies by error `type`.
   * @type {Attributes}
   * @memberof Error
   */
  attributes?: Attributes;
  /**
   * An optional localized string which provides hints for how the user or client can resolve the error.
   * @type {string}
   * @memberof Error
   */
  remediation?: string;
  /**
   * An optional array of nested error objects. This property is not always present.
   * @type {Array<Error>}
   * @memberof Error
   */
  errors?: Array<Error>;
  /**
   * An optional map of links, mapping each link relation to a link object. This model defines the `_links` object of HAL representations.
   * @type {{ [key: string]: Link; }}
   * @memberof Error
   */
  _links?: { [key: string]: Link };
}

/**
 * Describes an error response, typically returned on 4xx or 5xx errors from API operations. The `_error` object contains the error details.
 * @export
 * @interface ErrorResponse
 */
export interface ErrorResponse extends AbstractResource {}

/**
 * Describes a hypermedia link within a `_links` object in HAL representations. In Apiture APIs, links are [HAL links](https://developer.apiture.com/docs/concepts/links), but Apiture APIs do not use the `name` or `hreflang` properties of HAL. Apiture links _may_ include a `method` property.
 * @export
 * @interface Link
 */
export interface Link {
  /**
   * The URI or URI template for the resource/operation this link refers to.
   * @type {string}
   * @memberof Link
   */
  href: string;
  /**
   * The media type for the resource.
   * @type {string}
   * @memberof Link
   */
  type?: string;
  /**
   * If true, the link's href is a [URI template](https://tools.ietf.org/html/rfc6570).
   * @type {boolean}
   * @memberof Link
   */
  templated?: boolean;
  /**
   * An optional human-readable localized title for the link.
   * @type {string}
   * @memberof Link
   */
  title?: string;
  /**
   * If present, the containing link is deprecated and the value is a URI which provides human-readable text information about the deprecation.
   * @type {string}
   * @memberof Link
   */
  deprecation?: string;
  /**
   * The URI of a profile document, a JSON document which describes the target resource/operation.
   * @type {string}
   * @memberof Link
   */
  profile?: string;
}

/**
 * An optional map of links, mapping each link relation to a link object. This model defines the `_links` object of HAL representations.
 * @export
 * @interface Links
 */
export interface Links {
  [key: string]: Link;
}

/**
 * A HAL response, with hypermedia `_links` for the top-level resources and operations in API.
 * @export
 * @interface Root
 */
export interface Root extends AbstractResource {
  /**
   * This API's unique ID.
   * @type {string}
   * @memberof Root
   */
  _id?: string;
  /**
   * This API's name.
   * @type {string}
   * @memberof Root
   */
  name?: string;
  /**
   * This API's version.
   * @type {string}
   * @memberof Root
   */
  apiVersion?: string;
}

/**
 * Representation of statement resources.  This schema is version `v1.0.0`.
 * @export
 * @interface Statement
 */
export interface Statement extends SummaryStatement {}

/**
 * Each statement resource includes summary properties which describe the account.  This schema is version `v1.0.0`.
 * @export
 * @interface StatementFields
 */
export interface StatementFields {
  /**
   * The inclusive date in [RFC 3339](https://tools.ietf.org/html/rfc3339) `YYYY-MM-DD` format for the beginning of the statement period.
   * @type {string}
   * @memberof StatementFields
   */
  periodStartDate?: string;
  /**
   * The inclusive date in [RFC 3339](https://tools.ietf.org/html/rfc3339) `YYYY-MM-DD` format for the end of the statement period.
   * @type {string}
   * @memberof StatementFields
   */
  periodEndDate?: string;
  /**
   * The name of the account.
   * @type {string}
   * @memberof StatementFields
   */
  accountName?: string;
  /**
   * The title of the account holder.
   * @type {string}
   * @memberof StatementFields
   */
  accountTitle?: string;
  /**
   * The name of the financial institution.
   * @type {string}
   * @memberof StatementFields
   */
  institutionName?: string;
  /**
   * Account numbers.
   * @type {AccountNumbers}
   * @memberof StatementFields
   */
  accountNumbers?: AccountNumbers;
  /**
   * The account routing number which identifies the financial institution. The full routing number and full account number are required to fully identify the account.
   * @type {string}
   * @memberof StatementFields
   */
  routingNumber?: string;
}

/**
 * Collection of statements. The items in the collection are ordered in the `_embedded.items` array; the `name` is `statements`.  The top-level `_links` object may contain pagination links (`self`, `next`, `prev`, `first`, `last`, `collection`).  This schema is version `v1.0.0`.
 * @export
 * @interface Statements
 */
export interface Statements extends Collection {
  /**
   * Embedded objects.
   * @type {any}
   * @memberof Statements
   */
  _embedded?: any;
}

/**
 * Summary representation of a statement resource in statements collections. This representation normally does not contain any `_embedded` objects. If needed, call the `GET` operation on the item's `self` link to get `_embedded` objects. This object and contains a link (`apiture:statement`) to the downloadable statement document, typically PDF.  This schema is version `v1.0.0`.
 * @export
 * @interface SummaryStatement
 */
export interface SummaryStatement extends AbstractResource, StatementFields {
  /**
   * The unique identifier for this statement resource. This is an immutable opaque string.
   * @type {string}
   * @memberof SummaryStatement
   */
  _id?: string;
}

/**
 * APIApi - axios parameter creator
 * @export
 */
export const APIApiAxiosParamCreator = function(configuration?: SdkConfiguration) {
  return {
    /**
     * Return links to the top-level resources and operations in this API.  **Warning**: The getApi `operation` is **deprecated**. The getApi `operation` was deprecated on version `v0.7.0` of the API. `operation` will be removed on version `v1.0.0` of the API.
     * @summary Top-level resources and operations in this API
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     **/
    getApi(options: any = {}): RequestArgs {
      const localVarPath = `/`;
      const localVarUrlObj = Url.parse(localVarPath, true);
      let baseOptions;
      if (configuration) {
        baseOptions = configuration.baseOptions;
      }
      const localVarRequestOptions = Object.assign({ method: 'GET' }, baseOptions, options);
      const localVarHeaderParameter = baseOptions && baseOptions.headers ? baseOptions.headers : {};
      const localVarQueryParameter = {} as any;

      // authentication apiKey required
      if (configuration && configuration.apiKey) {
        const localVarApiKeyValue =
          typeof configuration.apiKey === 'function'
            ? configuration.apiKey('API-Key')
            : configuration.apiKey;
        localVarHeaderParameter['API-Key'] = localVarApiKeyValue;
      }

      localVarUrlObj.query = Object.assign(
        {},
        localVarUrlObj.query,
        localVarQueryParameter,
        options.query,
      );
      // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
      delete localVarUrlObj.search;
      localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

      return {
        url: Url.format(localVarUrlObj),
        options: localVarRequestOptions,
      };
    },
    /**
     * Return the OpenAPI document that describes this API.  **Warning**: The getApiDoc `operation` is **deprecated**. The getApiDoc `operation` was deprecated on version `v0.7.0` of the API. `operation` will be removed on version `v1.0.0` of the API.
     * @summary Return API definition document
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     **/
    getApiDoc(options: any = {}): RequestArgs {
      const localVarPath = `/apiDoc`;
      const localVarUrlObj = Url.parse(localVarPath, true);
      let baseOptions;
      if (configuration) {
        baseOptions = configuration.baseOptions;
      }
      const localVarRequestOptions = Object.assign({ method: 'GET' }, baseOptions, options);
      const localVarHeaderParameter = baseOptions && baseOptions.headers ? baseOptions.headers : {};
      const localVarQueryParameter = {} as any;

      // authentication apiKey required
      if (configuration && configuration.apiKey) {
        const localVarApiKeyValue =
          typeof configuration.apiKey === 'function'
            ? configuration.apiKey('API-Key')
            : configuration.apiKey;
        localVarHeaderParameter['API-Key'] = localVarApiKeyValue;
      }

      localVarUrlObj.query = Object.assign(
        {},
        localVarUrlObj.query,
        localVarQueryParameter,
        options.query,
      );
      // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
      delete localVarUrlObj.search;
      localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

      return {
        url: Url.format(localVarUrlObj),
        options: localVarRequestOptions,
      };
    },
  };
};

/**
 * APIApi - functional programming interface
 * @export
 */
export const APIApiFp = function(configuration?: SdkConfiguration) {
  return {
    /**
     * Return links to the top-level resources and operations in this API.  **Warning**: The getApi `operation` is **deprecated**. The getApi `operation` was deprecated on version `v0.7.0` of the API. `operation` will be removed on version `v1.0.0` of the API.
     * @summary Top-level resources and operations in this API
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     **/
    getApi(options?: any): (axios?: AxiosInstance, basePath?: string) => AxiosPromise<Root> {
      const localVarAxiosArgs = APIApiAxiosParamCreator(configuration).getApi(
        options ? options : {},
      );
      return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
        const axiosRequestArgs = Object.assign(localVarAxiosArgs.options, {
          url: basePath + localVarAxiosArgs.url,
        });
        return axios.request(axiosRequestArgs);
      };
    },
    /**
     * Return the OpenAPI document that describes this API.  **Warning**: The getApiDoc `operation` is **deprecated**. The getApiDoc `operation` was deprecated on version `v0.7.0` of the API. `operation` will be removed on version `v1.0.0` of the API.
     * @summary Return API definition document
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     **/
    getApiDoc(options?: any): (axios?: AxiosInstance, basePath?: string) => AxiosPromise<any> {
      const localVarAxiosArgs = APIApiAxiosParamCreator(configuration).getApiDoc(
        options ? options : {},
      );
      return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
        const axiosRequestArgs = Object.assign(localVarAxiosArgs.options, {
          url: basePath + localVarAxiosArgs.url,
        });
        return axios.request(axiosRequestArgs);
      };
    },
  };
};

/**
 * APIApi - factory interface
 * @export
 */
export const APIApiFactory = function(
  configuration?: SdkConfiguration,
  basePath?: string,
  axios?: AxiosInstance,
) {
  return {
    /**
     * Return links to the top-level resources and operations in this API.  **Warning**: The getApi `operation` is **deprecated**. The getApi `operation` was deprecated on version `v0.7.0` of the API. `operation` will be removed on version `v1.0.0` of the API.
     * @summary Top-level resources and operations in this API
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     **/
    getApi(options?: any) {
      return APIApiFp(configuration).getApi(options ? options : {})(axios, basePath);
    },
    /**
     * Return the OpenAPI document that describes this API.  **Warning**: The getApiDoc `operation` is **deprecated**. The getApiDoc `operation` was deprecated on version `v0.7.0` of the API. `operation` will be removed on version `v1.0.0` of the API.
     * @summary Return API definition document
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     **/
    getApiDoc(options?: any) {
      return APIApiFp(configuration).getApiDoc(options ? options : {})(axios, basePath);
    },
  };
};

/**
 * APIApi - object-oriented interface
 * @export
 * @class APIApi
 * @extends {BaseAPI}
 */
export class APIApi extends BaseAPI {
  constructor(config?: SdkConfiguration) {
    super(config);
  }
  /**
   * Return links to the top-level resources and operations in this API.  **Warning**: The getApi `operation` is **deprecated**. The getApi `operation` was deprecated on version `v0.7.0` of the API. `operation` will be removed on version `v1.0.0` of the API.
   * @summary Top-level resources and operations in this API
   * @param {*} [options] Override http request option.
   * @throws {RequiredError}
   * @returns {Root}
   * @memberof APIApi
   */
  public getApi(options?: any) {
    return APIApiFp(this.configuration).getApi(options ? options : {})(this.axios, this.basePath);
  }

  /**
   * Return the OpenAPI document that describes this API.  **Warning**: The getApiDoc `operation` is **deprecated**. The getApiDoc `operation` was deprecated on version `v0.7.0` of the API. `operation` will be removed on version `v1.0.0` of the API.
   * @summary Return API definition document
   * @param {*} [options] Override http request option.
   * @throws {RequiredError}
   * @returns {any}
   * @memberof APIApi
   */
  public getApiDoc(options?: any) {
    return APIApiFp(this.configuration).getApiDoc(options ? options : {})(
      this.axios,
      this.basePath,
    );
  }
}

/**
 * StatementApi - axios parameter creator
 * @export
 */
export const StatementApiAxiosParamCreator = function(configuration?: SdkConfiguration) {
  return {
    /**
     * Return a [HAL](http://developer.apiture.com/docs/concepts/hal) representation of this statement resource.  **Warning**: The getStatement `operation` is **deprecated**. The getStatement `operation` was deprecated on version `v0.7.0` of the API. `operation` will be removed on version `v1.0.0` of the API.
     * @summary Fetch a representation of this statement
     * @param {string} statementId The unique identifier of this statement. This is an opaque string.
     * @param {Object} [query] Query object
     * @param {boolean} [query.unmasked] When requesting an account, the full account number is not included in the response by default, for security reasons. Include this query parameter, with a value of &#x60;true&#x60;, to request that the response body includes the full account number. Such requests are auditable.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     **/
    getStatement(
      statementId: string,
      query?: { unmasked?: boolean },
      options: any = {},
    ): RequestArgs {
      const { unmasked } = query;

      // verify required parameter 'statementId' is not null or undefined
      if (statementId === null || statementId === undefined) {
        throw new RequiredError(
          'statementId',
          'Required parameter statementId was null or undefined when calling getStatement.',
        );
      }
      const localVarPath = `/statements/{statementId}`.replace(
        `{${'statementId'}}`,
        encodeURIComponent(String(statementId)),
      );
      const localVarUrlObj = Url.parse(localVarPath, true);
      let baseOptions;
      if (configuration) {
        baseOptions = configuration.baseOptions;
      }
      const localVarRequestOptions = Object.assign({ method: 'GET' }, baseOptions, options);
      const localVarHeaderParameter = baseOptions && baseOptions.headers ? baseOptions.headers : {};
      const localVarQueryParameter = {} as any;

      // authentication accessToken required
      // oauth required
      if (configuration && configuration.accessToken) {
        const localVarAccessTokenValue =
          typeof configuration.accessToken === 'function'
            ? configuration.accessToken('accessToken', [
                'banking/read',
                'banking/readBalance',
                'banking/full',
                'data/read',
              ])
            : configuration.accessToken;
        localVarHeaderParameter['Authorization'] = 'Bearer ' + localVarAccessTokenValue;
      }

      // authentication apiKey required
      if (configuration && configuration.apiKey) {
        const localVarApiKeyValue =
          typeof configuration.apiKey === 'function'
            ? configuration.apiKey('API-Key')
            : configuration.apiKey;
        localVarHeaderParameter['API-Key'] = localVarApiKeyValue;
      }

      if (unmasked !== undefined) {
        localVarQueryParameter['unmasked'] = unmasked;
      }

      localVarUrlObj.query = Object.assign(
        {},
        localVarUrlObj.query,
        localVarQueryParameter,
        options.query,
      );
      // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
      delete localVarUrlObj.search;
      localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

      return {
        url: Url.format(localVarUrlObj),
        options: localVarRequestOptions,
      };
    },
    /**
     * Return a [paginated](http://developer.apiture.com/docs/concepts/pagination) [sortable](http://developer.apiture.com/docs/concepts/sorting) [filterable](http://developer.apiture.com/docs/concepts/filtering) [searchable](http://developer.apiture.com/docs/concepts/searching) collection of statements. The [links](http://developer.apiture.com/docs/concepts/links) in the response include pagination links. Statements may be filtered in several ways:   1. Pass the `endDate` and a `period` which represents how far in the past to include. The `endDate` is the current date if omitted. For example, to fetch statements for the last six months, request `?period=P6M` query parameters. Each `prev` link will return the previous six months of statements. The default period if ommitted is `P6M`. Thus, the default request if none of `startDate`, `endDate` and `period` are passed is the last 6 months of statements. This implies a result sorted in _descending_ order by time.   1. Pass the `startDate` and/and `endDate`, to find any statements which overlap that date range. This implies a result sorted in ascending order by time.   1. Pass the `startDate` and a `period` which represents how far after the start date to include. For example, to fetch statements for the first six months of 2018, request `?startDate=2018-01-01&period=P6M` query parameters. Each `next` link in the response collection will return the next six months of statements, if available. This implies a result sorted in ascending order by time.   1. If accounts are included in the the optional `accounts` query parameter, only statements corresponding to those accounts to which the user is entitled will be returned.  An empty list of `_embedded.items` will be returned if the user is not entitled to any of the requested accounts.  **Warning**: The getStatements `operation` is **deprecated**. The getStatements `operation` was deprecated on version `v0.7.0` of the API. `operation` will be removed on version `v1.0.0` of the API.
     * @summary Return a collection of statements
     * @param {Object} [query] Query object
     * @param {number} [query.start] The zero-based index of the first statement item to include in this page. The default 0 denotes the beginning of the collection.
     * @param {number} [query.limit] The maximum number of statement representations to return in this page.
     * @param {string} [query.sortBy] Optional sort criteria. See [sort criteria format](http://developer.apiture.com/docs/concepts/sorting), such as &#x60;?sortBy&#x3D;field1,-field2&#x60;.
     * @param {string} [query.accounts] An optional comma or pipe (&#x60;|&#x60;) separated list list of account IDs. Note: these are _not_ account numbers but are the unique resource &#x60;_id&#x60; of the corresponding financial institution accounts. The user must have access to the corresponding accounts in order to view statements.
     * @param {string} [query.startDate] The start date of the query range.  May be combined with &#x60;endDate&#x60; _or_ &#x60;period&#x60; but not both.
     * @param {string} [query.endDate] The end date of the query range. May be combined with &#x60;endDate&#x60; _or_ &#x60;period&#x60; but not both.
     * @param {string} [query.period] The time period for the date range, looking backwards from &#x60;endDate&#x60; (or today, if &#x60;endDate&#x60; is omitted), or forward from &#x60;startDate&#x60;. For example, to list the statements for the last 6 months, use &#x60;?period&#x3D;P6m&#x60;.
     * @param {string} [query.filter] Optional filter criteria. See [filtering](http://developer.apiture.com/docs/concepts/filtering).
     * @param {string} [query.q] Optional search string. See [searching](http://developer.apiture.com/docs/concepts/searching).
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     **/
    getStatements(
      query?: {
        start?: number;
        limit?: number;
        sortBy?: string;
        accounts?: string;
        startDate?: Date;
        endDate?: Date;
        period?: string;
        filter?: string;
        q?: string;
      },
      options: any = {},
    ): RequestArgs {
      const { start, limit, sortBy, accounts, startDate, endDate, period, filter, q } = query;

      const localVarPath = `/statements`;
      const localVarUrlObj = Url.parse(localVarPath, true);
      let baseOptions;
      if (configuration) {
        baseOptions = configuration.baseOptions;
      }
      const localVarRequestOptions = Object.assign({ method: 'GET' }, baseOptions, options);
      const localVarHeaderParameter = baseOptions && baseOptions.headers ? baseOptions.headers : {};
      const localVarQueryParameter = {} as any;

      // authentication accessToken required
      // oauth required
      if (configuration && configuration.accessToken) {
        const localVarAccessTokenValue =
          typeof configuration.accessToken === 'function'
            ? configuration.accessToken('accessToken', [
                'banking/read',
                'banking/readBalance',
                'banking/full',
                'data/read',
              ])
            : configuration.accessToken;
        localVarHeaderParameter['Authorization'] = 'Bearer ' + localVarAccessTokenValue;
      }

      // authentication apiKey required
      if (configuration && configuration.apiKey) {
        const localVarApiKeyValue =
          typeof configuration.apiKey === 'function'
            ? configuration.apiKey('API-Key')
            : configuration.apiKey;
        localVarHeaderParameter['API-Key'] = localVarApiKeyValue;
      }

      if (start !== undefined) {
        localVarQueryParameter['start'] = start;
      }

      if (limit !== undefined) {
        localVarQueryParameter['limit'] = limit;
      }

      if (sortBy !== undefined) {
        localVarQueryParameter['sortBy'] = sortBy;
      }

      if (accounts !== undefined) {
        localVarQueryParameter['accounts'] = accounts;
      }

      if (startDate !== undefined) {
        localVarQueryParameter['startDate'] = (startDate as any).toISOString();
      }

      if (endDate !== undefined) {
        localVarQueryParameter['endDate'] = (endDate as any).toISOString();
      }

      if (period !== undefined) {
        localVarQueryParameter['period'] = period;
      }

      if (filter !== undefined) {
        localVarQueryParameter['filter'] = filter;
      }

      if (q !== undefined) {
        localVarQueryParameter['q'] = q;
      }

      localVarUrlObj.query = Object.assign(
        {},
        localVarUrlObj.query,
        localVarQueryParameter,
        options.query,
      );
      // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
      delete localVarUrlObj.search;
      localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

      return {
        url: Url.format(localVarUrlObj),
        options: localVarRequestOptions,
      };
    },
  };
};

/**
 * StatementApi - functional programming interface
 * @export
 */
export const StatementApiFp = function(configuration?: SdkConfiguration) {
  return {
    /**
     * Return a [HAL](http://developer.apiture.com/docs/concepts/hal) representation of this statement resource.  **Warning**: The getStatement `operation` is **deprecated**. The getStatement `operation` was deprecated on version `v0.7.0` of the API. `operation` will be removed on version `v1.0.0` of the API.
     * @summary Fetch a representation of this statement
     * @param {string} statementId The unique identifier of this statement. This is an opaque string.
     * @param {Object} [query] Query object
     * @param {boolean} [query.unmasked] When requesting an account, the full account number is not included in the response by default, for security reasons. Include this query parameter, with a value of &#x60;true&#x60;, to request that the response body includes the full account number. Such requests are auditable.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     **/
    getStatement(
      statementId: string,
      query?: { unmasked?: boolean },
      options?: any,
    ): (axios?: AxiosInstance, basePath?: string) => AxiosPromise<Statement> {
      const localVarAxiosArgs = StatementApiAxiosParamCreator(configuration).getStatement(
        statementId ? statementId : null,
        query ? query : {},
        options ? options : {},
      );
      return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
        const axiosRequestArgs = Object.assign(localVarAxiosArgs.options, {
          url: basePath + localVarAxiosArgs.url,
        });
        return axios.request(axiosRequestArgs);
      };
    },
    /**
     * Return a [paginated](http://developer.apiture.com/docs/concepts/pagination) [sortable](http://developer.apiture.com/docs/concepts/sorting) [filterable](http://developer.apiture.com/docs/concepts/filtering) [searchable](http://developer.apiture.com/docs/concepts/searching) collection of statements. The [links](http://developer.apiture.com/docs/concepts/links) in the response include pagination links. Statements may be filtered in several ways:   1. Pass the `endDate` and a `period` which represents how far in the past to include. The `endDate` is the current date if omitted. For example, to fetch statements for the last six months, request `?period=P6M` query parameters. Each `prev` link will return the previous six months of statements. The default period if ommitted is `P6M`. Thus, the default request if none of `startDate`, `endDate` and `period` are passed is the last 6 months of statements. This implies a result sorted in _descending_ order by time.   1. Pass the `startDate` and/and `endDate`, to find any statements which overlap that date range. This implies a result sorted in ascending order by time.   1. Pass the `startDate` and a `period` which represents how far after the start date to include. For example, to fetch statements for the first six months of 2018, request `?startDate=2018-01-01&period=P6M` query parameters. Each `next` link in the response collection will return the next six months of statements, if available. This implies a result sorted in ascending order by time.   1. If accounts are included in the the optional `accounts` query parameter, only statements corresponding to those accounts to which the user is entitled will be returned.  An empty list of `_embedded.items` will be returned if the user is not entitled to any of the requested accounts.  **Warning**: The getStatements `operation` is **deprecated**. The getStatements `operation` was deprecated on version `v0.7.0` of the API. `operation` will be removed on version `v1.0.0` of the API.
     * @summary Return a collection of statements
     * @param {Object} [query] Query object
     * @param {number} [query.start] The zero-based index of the first statement item to include in this page. The default 0 denotes the beginning of the collection.
     * @param {number} [query.limit] The maximum number of statement representations to return in this page.
     * @param {string} [query.sortBy] Optional sort criteria. See [sort criteria format](http://developer.apiture.com/docs/concepts/sorting), such as &#x60;?sortBy&#x3D;field1,-field2&#x60;.
     * @param {string} [query.accounts] An optional comma or pipe (&#x60;|&#x60;) separated list list of account IDs. Note: these are _not_ account numbers but are the unique resource &#x60;_id&#x60; of the corresponding financial institution accounts. The user must have access to the corresponding accounts in order to view statements.
     * @param {string} [query.startDate] The start date of the query range.  May be combined with &#x60;endDate&#x60; _or_ &#x60;period&#x60; but not both.
     * @param {string} [query.endDate] The end date of the query range. May be combined with &#x60;endDate&#x60; _or_ &#x60;period&#x60; but not both.
     * @param {string} [query.period] The time period for the date range, looking backwards from &#x60;endDate&#x60; (or today, if &#x60;endDate&#x60; is omitted), or forward from &#x60;startDate&#x60;. For example, to list the statements for the last 6 months, use &#x60;?period&#x3D;P6m&#x60;.
     * @param {string} [query.filter] Optional filter criteria. See [filtering](http://developer.apiture.com/docs/concepts/filtering).
     * @param {string} [query.q] Optional search string. See [searching](http://developer.apiture.com/docs/concepts/searching).
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     **/
    getStatements(
      query?: {
        start?: number;
        limit?: number;
        sortBy?: string;
        accounts?: string;
        startDate?: Date;
        endDate?: Date;
        period?: string;
        filter?: string;
        q?: string;
      },
      options?: any,
    ): (axios?: AxiosInstance, basePath?: string) => AxiosPromise<Statements> {
      const localVarAxiosArgs = StatementApiAxiosParamCreator(configuration).getStatements(
        query ? query : {},
        options ? options : {},
      );
      return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
        const axiosRequestArgs = Object.assign(localVarAxiosArgs.options, {
          url: basePath + localVarAxiosArgs.url,
        });
        return axios.request(axiosRequestArgs);
      };
    },
  };
};

/**
 * StatementApi - factory interface
 * @export
 */
export const StatementApiFactory = function(
  configuration?: SdkConfiguration,
  basePath?: string,
  axios?: AxiosInstance,
) {
  return {
    /**
     * Return a [HAL](http://developer.apiture.com/docs/concepts/hal) representation of this statement resource.  **Warning**: The getStatement `operation` is **deprecated**. The getStatement `operation` was deprecated on version `v0.7.0` of the API. `operation` will be removed on version `v1.0.0` of the API.
     * @summary Fetch a representation of this statement
     * @param {string} statementId The unique identifier of this statement. This is an opaque string.
     * @param {Object} [query] Query object
     * @param {boolean} [query.unmasked] When requesting an account, the full account number is not included in the response by default, for security reasons. Include this query parameter, with a value of &#x60;true&#x60;, to request that the response body includes the full account number. Such requests are auditable.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     **/
    getStatement(statementId: string, query?: { unmasked?: boolean }, options?: any) {
      return StatementApiFp(configuration).getStatement(
        statementId ? statementId : null,
        query ? query : {},
        options ? options : {},
      )(axios, basePath);
    },
    /**
     * Return a [paginated](http://developer.apiture.com/docs/concepts/pagination) [sortable](http://developer.apiture.com/docs/concepts/sorting) [filterable](http://developer.apiture.com/docs/concepts/filtering) [searchable](http://developer.apiture.com/docs/concepts/searching) collection of statements. The [links](http://developer.apiture.com/docs/concepts/links) in the response include pagination links. Statements may be filtered in several ways:   1. Pass the `endDate` and a `period` which represents how far in the past to include. The `endDate` is the current date if omitted. For example, to fetch statements for the last six months, request `?period=P6M` query parameters. Each `prev` link will return the previous six months of statements. The default period if ommitted is `P6M`. Thus, the default request if none of `startDate`, `endDate` and `period` are passed is the last 6 months of statements. This implies a result sorted in _descending_ order by time.   1. Pass the `startDate` and/and `endDate`, to find any statements which overlap that date range. This implies a result sorted in ascending order by time.   1. Pass the `startDate` and a `period` which represents how far after the start date to include. For example, to fetch statements for the first six months of 2018, request `?startDate=2018-01-01&period=P6M` query parameters. Each `next` link in the response collection will return the next six months of statements, if available. This implies a result sorted in ascending order by time.   1. If accounts are included in the the optional `accounts` query parameter, only statements corresponding to those accounts to which the user is entitled will be returned.  An empty list of `_embedded.items` will be returned if the user is not entitled to any of the requested accounts.  **Warning**: The getStatements `operation` is **deprecated**. The getStatements `operation` was deprecated on version `v0.7.0` of the API. `operation` will be removed on version `v1.0.0` of the API.
     * @summary Return a collection of statements
     * @param {Object} [query] Query object
     * @param {number} [query.start] The zero-based index of the first statement item to include in this page. The default 0 denotes the beginning of the collection.
     * @param {number} [query.limit] The maximum number of statement representations to return in this page.
     * @param {string} [query.sortBy] Optional sort criteria. See [sort criteria format](http://developer.apiture.com/docs/concepts/sorting), such as &#x60;?sortBy&#x3D;field1,-field2&#x60;.
     * @param {string} [query.accounts] An optional comma or pipe (&#x60;|&#x60;) separated list list of account IDs. Note: these are _not_ account numbers but are the unique resource &#x60;_id&#x60; of the corresponding financial institution accounts. The user must have access to the corresponding accounts in order to view statements.
     * @param {string} [query.startDate] The start date of the query range.  May be combined with &#x60;endDate&#x60; _or_ &#x60;period&#x60; but not both.
     * @param {string} [query.endDate] The end date of the query range. May be combined with &#x60;endDate&#x60; _or_ &#x60;period&#x60; but not both.
     * @param {string} [query.period] The time period for the date range, looking backwards from &#x60;endDate&#x60; (or today, if &#x60;endDate&#x60; is omitted), or forward from &#x60;startDate&#x60;. For example, to list the statements for the last 6 months, use &#x60;?period&#x3D;P6m&#x60;.
     * @param {string} [query.filter] Optional filter criteria. See [filtering](http://developer.apiture.com/docs/concepts/filtering).
     * @param {string} [query.q] Optional search string. See [searching](http://developer.apiture.com/docs/concepts/searching).
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     **/
    getStatements(
      query?: {
        start?: number;
        limit?: number;
        sortBy?: string;
        accounts?: string;
        startDate?: Date;
        endDate?: Date;
        period?: string;
        filter?: string;
        q?: string;
      },
      options?: any,
    ) {
      return StatementApiFp(configuration).getStatements(
        query ? query : {},
        options ? options : {},
      )(axios, basePath);
    },
  };
};

/**
 * StatementApi - object-oriented interface
 * @export
 * @class StatementApi
 * @extends {BaseAPI}
 */
export class StatementApi extends BaseAPI {
  constructor(config?: SdkConfiguration) {
    super(config);
  }
  /**
   * Return a [HAL](http://developer.apiture.com/docs/concepts/hal) representation of this statement resource.  **Warning**: The getStatement `operation` is **deprecated**. The getStatement `operation` was deprecated on version `v0.7.0` of the API. `operation` will be removed on version `v1.0.0` of the API.
   * @summary Fetch a representation of this statement
   * @param {string} statementId The unique identifier of this statement. This is an opaque string.
   * @param {Object} [query] Query object
   * @param {boolean} [query.unmasked] When requesting an account, the full account number is not included in the response by default, for security reasons. Include this query parameter, with a value of &#x60;true&#x60;, to request that the response body includes the full account number. Such requests are auditable.
   * @param {*} [options] Override http request option.
   * @throws {RequiredError}
   * @returns {Statement}
   * @memberof StatementApi
   */
  public getStatement(statementId: string, query?: { unmasked?: boolean }, options?: any) {
    return StatementApiFp(this.configuration).getStatement(
      statementId ? statementId : null,
      query ? query : {},
      options ? options : {},
    )(this.axios, this.basePath);
  }

  /**
   * Return a [paginated](http://developer.apiture.com/docs/concepts/pagination) [sortable](http://developer.apiture.com/docs/concepts/sorting) [filterable](http://developer.apiture.com/docs/concepts/filtering) [searchable](http://developer.apiture.com/docs/concepts/searching) collection of statements. The [links](http://developer.apiture.com/docs/concepts/links) in the response include pagination links. Statements may be filtered in several ways:   1. Pass the `endDate` and a `period` which represents how far in the past to include. The `endDate` is the current date if omitted. For example, to fetch statements for the last six months, request `?period=P6M` query parameters. Each `prev` link will return the previous six months of statements. The default period if ommitted is `P6M`. Thus, the default request if none of `startDate`, `endDate` and `period` are passed is the last 6 months of statements. This implies a result sorted in _descending_ order by time.   1. Pass the `startDate` and/and `endDate`, to find any statements which overlap that date range. This implies a result sorted in ascending order by time.   1. Pass the `startDate` and a `period` which represents how far after the start date to include. For example, to fetch statements for the first six months of 2018, request `?startDate=2018-01-01&period=P6M` query parameters. Each `next` link in the response collection will return the next six months of statements, if available. This implies a result sorted in ascending order by time.   1. If accounts are included in the the optional `accounts` query parameter, only statements corresponding to those accounts to which the user is entitled will be returned.  An empty list of `_embedded.items` will be returned if the user is not entitled to any of the requested accounts.  **Warning**: The getStatements `operation` is **deprecated**. The getStatements `operation` was deprecated on version `v0.7.0` of the API. `operation` will be removed on version `v1.0.0` of the API.
   * @summary Return a collection of statements
   * @param {Object} [query] Query object
   * @param {number} [query.start] The zero-based index of the first statement item to include in this page. The default 0 denotes the beginning of the collection.
   * @param {number} [query.limit] The maximum number of statement representations to return in this page.
   * @param {string} [query.sortBy] Optional sort criteria. See [sort criteria format](http://developer.apiture.com/docs/concepts/sorting), such as &#x60;?sortBy&#x3D;field1,-field2&#x60;.
   * @param {string} [query.accounts] An optional comma or pipe (&#x60;|&#x60;) separated list list of account IDs. Note: these are _not_ account numbers but are the unique resource &#x60;_id&#x60; of the corresponding financial institution accounts. The user must have access to the corresponding accounts in order to view statements.
   * @param {string} [query.startDate] The start date of the query range.  May be combined with &#x60;endDate&#x60; _or_ &#x60;period&#x60; but not both.
   * @param {string} [query.endDate] The end date of the query range. May be combined with &#x60;endDate&#x60; _or_ &#x60;period&#x60; but not both.
   * @param {string} [query.period] The time period for the date range, looking backwards from &#x60;endDate&#x60; (or today, if &#x60;endDate&#x60; is omitted), or forward from &#x60;startDate&#x60;. For example, to list the statements for the last 6 months, use &#x60;?period&#x3D;P6m&#x60;.
   * @param {string} [query.filter] Optional filter criteria. See [filtering](http://developer.apiture.com/docs/concepts/filtering).
   * @param {string} [query.q] Optional search string. See [searching](http://developer.apiture.com/docs/concepts/searching).
   * @param {*} [options] Override http request option.
   * @throws {RequiredError}
   * @returns {Statements}
   * @memberof StatementApi
   */
  public getStatements(
    query?: {
      start?: number;
      limit?: number;
      sortBy?: string;
      accounts?: string;
      startDate?: Date;
      endDate?: Date;
      period?: string;
      filter?: string;
      q?: string;
    },
    options?: any,
  ) {
    return StatementApiFp(this.configuration).getStatements(
      query ? query : {},
      options ? options : {},
    )(this.axios, this.basePath);
  }
}
