# @apiture/users-client-sdk@0.18.7
Typescript/Javascript client SDK that using [axios](https://github.com/axios/axios) as core http client.
It also include a collection of Typescript Definition interfaces.

## Installation
```
npm install @apiture/users-client-sdk@0.18.7 --save
```

## Usage

```typescript
import { SdkConfiguration, APIApi, AddressApi, ConfigurationApi, EmailAddressApi, PhoneNumberApi, UserApi, UserActionsApi } from "@apiture/users-client-sdk";

  // Define a configuration object [ optional ]
  const configuration: SdkConfiguration = {
    host: "api.institution.com", // [ optional ] Api host 
    accessToken: token, // [ optional ] Oauth2 Authorization token 
  };


// Instantiate APIApi main class passing the configuration object.
    const aPIApi = new APIApi(configuration);

// Instantiate AddressApi main class passing the configuration object.
    const addressApi = new AddressApi(configuration);

// Instantiate ConfigurationApi main class passing the configuration object.
    const configurationApi = new ConfigurationApi(configuration);

// Instantiate EmailAddressApi main class passing the configuration object.
    const emailAddressApi = new EmailAddressApi(configuration);

// Instantiate PhoneNumberApi main class passing the configuration object.
    const phoneNumberApi = new PhoneNumberApi(configuration);

// Instantiate UserApi main class passing the configuration object.
    const userApi = new UserApi(configuration);

// Instantiate UserActionsApi main class passing the configuration object.
    const userActionsApi = new UserActionsApi(configuration);


// Use the methods to call the apis ( Refer to the Users SDK Classes and Methods list ).
  userActions.activateUser().then( response => {
    const activateuserData = response.data;
    const headers = response.headers;
  });



// Use the methods to call the apis ( Refer to the Users SDK Classes and Methods list ).
  userActions.deactivateUser().then( response => {
    const deactivateuserData = response.data;
    const headers = response.headers;
  });



// Use the methods to call the apis ( Refer to the Users SDK Classes and Methods list ).
  userActions.freezeUser().then( response => {
    const freezeuserData = response.data;
    const headers = response.headers;
  });



// Use the methods to call the apis ( Refer to the Users SDK Classes and Methods list ).
  userActions.lockUser().then( response => {
    const lockuserData = response.data;
    const headers = response.headers;
  });



// Use the methods to call the apis ( Refer to the Users SDK Classes and Methods list ).
  userActions.removeUser().then( response => {
    const removeuserData = response.data;
    const headers = response.headers;
  });


```

## Updating configuration values.
The SDK can be instantiated without a configuration object. If that's the case it would need to receive configuration values after.
List of values available to setup after instantiated.
- host
- accessToken
- apiKey

```typescript
// Instantiate UserActionsApi main class.
    const userActionsApi = new UserActionsApi();


// Update the accessToken using the class method `setAccessToken`.
    userActionsApi.setAccessToken(newAccessToken);

// Update the host using the class method `setHost`.
    userActionsApi.setHost("api.staging.institution.com");

// Update the apiKey using the class method `setApiKey`.
    userActionsApi.setApiKey(newApiKey);

// Instantiate UserActionsApi main class.
    const userActionsApi = new UserActionsApi();


// Update the accessToken using the class method `setAccessToken`.
    userActionsApi.setAccessToken(newAccessToken);

// Update the host using the class method `setHost`.
    userActionsApi.setHost("api.staging.institution.com");

// Update the apiKey using the class method `setApiKey`.
    userActionsApi.setApiKey(newApiKey);

// Instantiate UserActionsApi main class.
    const userActionsApi = new UserActionsApi();


// Update the accessToken using the class method `setAccessToken`.
    userActionsApi.setAccessToken(newAccessToken);

// Update the host using the class method `setHost`.
    userActionsApi.setHost("api.staging.institution.com");

// Update the apiKey using the class method `setApiKey`.
    userActionsApi.setApiKey(newApiKey);

// Instantiate UserActionsApi main class.
    const userActionsApi = new UserActionsApi();


// Update the accessToken using the class method `setAccessToken`.
    userActionsApi.setAccessToken(newAccessToken);

// Update the host using the class method `setHost`.
    userActionsApi.setHost("api.staging.institution.com");

// Update the apiKey using the class method `setApiKey`.
    userActionsApi.setApiKey(newApiKey);

// Instantiate UserActionsApi main class.
    const userActionsApi = new UserActionsApi();


// Update the accessToken using the class method `setAccessToken`.
    userActionsApi.setAccessToken(newAccessToken);

// Update the host using the class method `setHost`.
    userActionsApi.setHost("api.staging.institution.com");

// Update the apiKey using the class method `setApiKey`.
    userActionsApi.setApiKey(newApiKey);


```

## Using Typescript interfaces only
If you want to only use the interfaces you can export them individually or create an scope import directly from the package.

```typescript

  // ______ Individual Import

  import { User } from "@apiture/users-client-sdk";

  const stronglyTypedObject :User = { ... };

  // ______ Scoped import

  import * as UsersTypes from "@apiture/users-client-sdk";

  const stronglyTypedObject :UsersTypes.User = { ... };

  // ______ Individual Import

  import { User } from "@apiture/users-client-sdk";

  const stronglyTypedObject :User = { ... };

  // ______ Scoped import

  import * as UsersTypes from "@apiture/users-client-sdk";

  const stronglyTypedObject :UsersTypes.User = { ... };

  // ______ Individual Import

  import { User } from "@apiture/users-client-sdk";

  const stronglyTypedObject :User = { ... };

  // ______ Scoped import

  import * as UsersTypes from "@apiture/users-client-sdk";

  const stronglyTypedObject :UsersTypes.User = { ... };

  // ______ Individual Import

  import { User } from "@apiture/users-client-sdk";

  const stronglyTypedObject :User = { ... };

  // ______ Scoped import

  import * as UsersTypes from "@apiture/users-client-sdk";

  const stronglyTypedObject :UsersTypes.User = { ... };

  // ______ Individual Import

  import { User } from "@apiture/users-client-sdk";

  const stronglyTypedObject :User = { ... };

  // ______ Scoped import

  import * as UsersTypes from "@apiture/users-client-sdk";

  const stronglyTypedObject :UsersTypes.User = { ... };

```

## SdkConfiguration object
The SDK configuration object provides a convenient way to initialize all the SDK classes reusing the same object. **Below is the full list of options allowed.**
```typescript
  const configuration: SdkConfiguration = {
    
    host: "api.institution.com", 
    // [ optional ] Api host, protocol allowed as well. ( https://api.institution.com )

    accessToken: token, 
    // [ optional ] Oauth2 Authorization token  
    
    apiKey: key, 
    // [ optional ] Apiture apiKey 
    
    baseOptions: {
      headers: {
        "a-global-header-key": "a global header value",
      },
    },
    // [ optional ] Extend Axios global config 

    basePath: "/users",
    // [ optional ] Overrides the BasePath (Not necessary in 90% of cases)
  }
  ```

## Users SDK Classes and Methods
---


### APIApi


  `APIApi.getApi` - Top-level resources and operations in this API

  `APIApi.getApiDoc` - Return API definition document

  `APIApi.getLabels` - Localized Labels



### AddressApi


  `AddressApi.createAddress` - Create a new address

  `AddressApi.deleteAddress` - Delete this address resource

  `AddressApi.getAddress` - Fetch a representation of this address

  `AddressApi.getAddresses` - Get user&#39;s addresses

  `AddressApi.setPreferredAddress` - Set Preferred mailing Address



### ConfigurationApi


  `ConfigurationApi.getConfigurationGroup` - Fetch a representation of this configuration group

  `ConfigurationApi.getConfigurationGroupSchema` - Fetch the schema for this configuration group

  `ConfigurationApi.getConfigurationGroupValue` - Fetch a single value associated with the specified configuration group

  `ConfigurationApi.getConfigurationGroupValues` - Fetch the values for the specified configuration group

  `ConfigurationApi.getConfigurationGroups` - Return a collection of configuration groups

  `ConfigurationApi.updateConfigurationGroupValue` - Update a single value associated with the specified configuration group

  `ConfigurationApi.updateConfigurationGroupValues` - Update the values for the specified configuration group



### EmailAddressApi


  `EmailAddressApi.createEmailAddress` - Create a new email address

  `EmailAddressApi.deleteEmailAddress` - Delete this email address resource

  `EmailAddressApi.getEmailAddress` - Fetch a representation of this email address

  `EmailAddressApi.getEmailAddresses` - Get user&#39;s email addresses

  `EmailAddressApi.setPreferredEmailAddress` - Set Preferred Email Address



### PhoneNumberApi


  `PhoneNumberApi.createPhoneNumber` - Create a new phone number

  `PhoneNumberApi.deletePhoneNumber` - Delete this phone number resource

  `PhoneNumberApi.getPhoneNumber` - Fetch a representation of this phone number

  `PhoneNumberApi.getPhoneNumbers` - Get user&#39;s phone numbers

  `PhoneNumberApi.setPreferredPhoneNumber` - Set Preferred Phone Number



### UserApi


  `UserApi.createUser` - Create a new user

  `UserApi.getUser` - Fetch a representation of this user

  `UserApi.getUserConstraints` - Fetch a representation of this user&#39;s constraints

  `UserApi.getUsers` - Return a collection of users

  `UserApi.patchUser` - Update this user

  `UserApi.patchUserConstraints` - Update this  user&#39;s constraints

  `UserApi.updateUser` - Update this user

  `UserApi.updateUserConstraints` - Update this user&#39;s constraints



### UserActionsApi


  `UserActionsApi.activateUser` - Activate a user

  `UserActionsApi.deactivateUser` - Deactivate a user

  `UserActionsApi.freezeUser` - Freeze a user

  `UserActionsApi.lockUser` - Lock a user

  `UserActionsApi.mergeUsers` - Merge a set of users

  `UserActionsApi.removeUser` - Remove a user



## About the Users API
___
The Users API provides operations to create and maintain online customers for the financial institution. A user represents a person who has registered for online digital banking. Each user resource contains contact information about them (their name, addresses, phone numbers, email addresses) as well as birthdate, government identification, citizenship, and other information that allows the financial institution to conform to regulations related to customers. Every user is uniquely identifiable by a system-generated unique identifier. Users can be created (never deleted) and the state of a user can be modified by authorized financial institution administrators. This API also maintains other banking information about a user, such as their funds transfer limits or other constraints. In addition to the basic operations to create and modify users, there are several actions supported for users. API [links](http://developer.apiture.com/docs/concepts/links) for these actions are described in the `user` schema.   * Lock - if someone attempts to log in with an incorrect password too many times,     the user is locked.     (`POST /lockedUsers?user={userId}`).     The user can be unlocked by resetting their password.     Unlocking a user is done by reactivating them     (`POST /activeUsers?user={userId}`).   * Deactivate - If the financial institution wishes to suspend a user's activity.     (`POST /inactiveUsers?user={userId}`).     Inactive users can be reactivated     (`POST /activeUsers?user={userId}`)`.   * Freeze - If the financial institution suspects fraudulent use of a user's account,     they can freeze a user.     (`POST /frozenUsers?user={userId}`).     Unfreezing a user is done by reactivating them     (`POST /activeUsers?user={userId}`)`.   * Remove - The financial institution can remove a user when they leave the financial institution.     (`POST /removedUsers?user={userId}`).     The user resource is retained rather than being deleted, so that other audit     and other information that references the user remains valid. This API also supports service configuration operations. ## Multi-factor authentication challenges To prevent account takeover attacks, some operations to update the user's profile require _multi-factor authentication_ (MFA). An MFA _challenge_ is a process to verify the user's identity through one or more additional authentication steps.  Some examples are the operations which change the user's preferred phone number:   1. `setPreferredPhoneNumber` operation   1. `createPhoneNumber` operation when the `?replaceId` names the current preferred phone number.   Both require an MFA challenge. When the client tries the operation without a valid redeemable `Apiture-Challenge` request header, the operation may fail with a 409 Conflict. The response body, defined by the `challengeErrorResponse` schema, contains a `challenge` resource which includes one or more _authenticators_. The client should start at least one of the authenticators, optionally allowing the user choose which ones to use, depending on how many authenticators are required.  When changing the user's preferred phone number, for example, the challenge may include an authenticator that sends a verification code to the user's email account. The user completes the authentication by entering the code in the client application. Once the authentication step has completed successfully, the client must pass the resource ID of the challenge resource in the `Apiture-Challenge` request header in order for the operation to update the user's profile information. Thus, these operations often require two tries: the first (without the `Apiture-Challenge` header), which fails with a 409 status but returns the challenge object, then after completing the challenges' authenticators, a second try, passing in the `Apiture-Challenge` header.
