// tslint:disable
/**
 * Users
 * The Users API provides operations to create and maintain online customers for the financial institution. A user represents a person who has registered for online digital banking. Each user resource contains contact information about them (their name, addresses, phone numbers, email addresses) as well as birthdate, government identification, citizenship, and other information that allows the financial institution to conform to regulations related to customers. Every user is uniquely identifiable by a system-generated unique identifier. Users can be created (never deleted) and the state of a user can be modified by authorized financial institution administrators. This API also maintains other banking information about a user, such as their funds transfer limits or other constraints. In addition to the basic operations to create and modify users, there are several actions supported for users. API [links](http://developer.apiture.com/docs/concepts/links) for these actions are described in the `user` schema.   * Lock - if someone attempts to log in with an incorrect password too many times,     the user is locked.     (`POST /lockedUsers?user={userId}`).     The user can be unlocked by resetting their password.     Unlocking a user is done by reactivating them     (`POST /activeUsers?user={userId}`).   * Deactivate - If the financial institution wishes to suspend a user's activity.     (`POST /inactiveUsers?user={userId}`).     Inactive users can be reactivated     (`POST /activeUsers?user={userId}`)`.   * Freeze - If the financial institution suspects fraudulent use of a user's account,     they can freeze a user.     (`POST /frozenUsers?user={userId}`).     Unfreezing a user is done by reactivating them     (`POST /activeUsers?user={userId}`)`.   * Remove - The financial institution can remove a user when they leave the financial institution.     (`POST /removedUsers?user={userId}`).     The user resource is retained rather than being deleted, so that other audit     and other information that references the user remains valid. This API also supports service configuration operations. ## Multi-factor authentication challenges To prevent account takeover attacks, some operations to update the user's profile require _multi-factor authentication_ (MFA). An MFA _challenge_ is a process to verify the user's identity through one or more additional authentication steps.  Some examples are the operations which change the user's preferred phone number:   1. `setPreferredPhoneNumber` operation   1. `createPhoneNumber` operation when the `?replaceId` names the current preferred phone number.   Both require an MFA challenge. When the client tries the operation without a valid redeemable `Apiture-Challenge` request header, the operation may fail with a 409 Conflict. The response body, defined by the `challengeErrorResponse` schema, contains a `challenge` resource which includes one or more _authenticators_. The client should start at least one of the authenticators, optionally allowing the user choose which ones to use, depending on how many authenticators are required.  When changing the user's preferred phone number, for example, the challenge may include an authenticator that sends a verification code to the user's email account. The user completes the authentication by entering the code in the client application. Once the authentication step has completed successfully, the client must pass the resource ID of the challenge resource in the `Apiture-Challenge` request header in order for the operation to update the user's profile information. Thus, these operations often require two tries: the first (without the `Apiture-Challenge` header), which fails with a 409 status but returns the challenge object, then after completing the challenges' authenticators, a second try, passing in the `Apiture-Challenge` header.
 *
 * OpenAPI spec version: 0.18.7
 * Contact: api@apiture.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

export * from './api';
export * from './configuration';
